<template>
<div class="lobby">
	<div class="container player-list-container">
		<player-list
			:local="this.local"
			:players="this.player_data"
		/>
	</div>
	<div class="container options">
		<div class="details">
			<div v-if="!this.local"><b>{{ name }}</b></div>
			<div>[<i>Map</i>] {{ map_name }}</div>
			<div>[<i>Mode</i>] {{ mode_name }}</div>
			<div>[<i>Teams</i>] {{ teams_name }}</div>
		</div>
		<div class="messages" v-if="!this.local">
			<div
				v-for="message in message_list"
				class="message"
				:key="message.id"
			><span class="speaker">{{ message.name}}</span>: {{ message.text }}</div>
		</div>
		<div class="chatbox" v-if="!this.local">
			<input-item
				:id="0"
				v-on:change="this.setMessage"
				v-on:hover="this.setSelected"
				ref="msg_box"
				:fullwidth="true"
				:limit="64"
				:selected="this.selected === 0"
				:value="this.message"
			/>
			<standard-item
				:id="1"
				v-on:click="this.sendMessage"
				v-on:hover="this.setSelected"
				:selected="this.selected === 1"
			>Send</standard-item>
		</div>
		<div class="buttons">
			<standard-item
				:id="2"
				v-if="!this.local"
				v-on:click="this.toggleReady"
				v-on:hover="this.setSelected"
				:selected="this.selected === 2"
			>{{ am_ready ? "Not Ready" : "Ready" }}</standard-item>
			<standard-item
				:id="2"
				v-if="this.local"
				v-on:click="this.startLocalGame"
				v-on:hover="this.setSelected"
				:selected="this.selected === 2"
			>Start</standard-item>
			<standard-item
				:id="3"
				v-on:click="this.leaveLobby"
				v-on:hover="this.setSelected"
				:selected="this.selected === 3"
			>Leave Lobby</standard-item>
		</div>
		<div class="buttons">
			<standard-item
				:id="4"
				v-if="this.local || this.hosting"
				v-on:click="this.changeSettings"
				v-on:hover="this.setSelected"
				:selected="this.selected === 4"
			>Change Settings</standard-item>
		</div>
	</div>
</div>
</template>

<script>
import MapOptions from "../../../common/constants/MapOptions.js"
import ModeOptions from "../../../common/constants/ModeOptions.js"
import TeamOptions from "../../../common/constants/TeamOptions.js"

import InputItem from "./InputItem.vue"
import PlayerList from "./PlayerList.vue"
import StandardItem from "./StandardItem.vue"

export default {
	components: { InputItem, PlayerList, StandardItem },
	computed: {
		am_ready () {
			if (this.self) return this.self.is_ready
		},
		map_name () {
			const map = MapOptions.find((map) => {
				return this.map === map.id
			})
			return map ? map.name : ""
		},
		message_list () {
			const dict = {}

			this.players.forEach((player) => {
				dict[player.id] = player.name
			})

			return this.messages.map((msg, id) => {
				return {
					id: id,
					name: dict[msg.id],
					text: msg.data
				}
			})
		},
		mode_name () {
			const mode = ModeOptions.find((mode) => {
				return this.mode === mode.id
			})
			return mode ? mode.name : ""
		},
		player_data () {
			const data = (this.players || []).slice(0)
			while (data.length < this.teamsize) {
				data.push({
					id: "AI",
					is_ai: true,
					is_ready: true,
					name: "AI"
				})
			}
			return data
		},
		self () {
			return this.players.find((player) => {
				return player.id === Networker.id
			})
		},
		teams_name () {
			const teams = TeamOptions.find((teams) => {
				return this.teams === teams.id
			})
			return teams ? teams.name : ""
		}
	},
	data () {
		return {
			message: "",
			selected: this.local ? 2 : 0
		}
	},
	methods: {
		beforeDestroy () {
			UI.off("PRESS_BACK", this.onPressBack)
			UI.off("PRESS_DOWN", this.onPressDown)
			UI.off("PRESS_ENTER", this.onPressEnter)
			UI.off("PRESS_LEFT", this.onPressLeft)
			UI.off("PRESS_RIGHT", this.onPressRight)
			UI.off("PRESS_UP", this.onPressUp)
		},
		changeSettings () {
			console.log("yeahright")
		},
		leaveLobby () {
			UI.emit("GO_BACK")
		},
		onPressLeft () {
			if (this.selected % 2 === 1) this.selected--
		},
		onPressRight () {
			const ref = this.$refs.msg_box
			const can = (this.local && this.selected < 4) || (ref && !ref.focused)
			if (this.selected % 2 === 0 && can) this.selected++
		},
		onPressUp () {
			if (this.selected > 1) this.selected -= 2
			if (this.local && this.selected < 2) this.selected = 2
		},
		onPressDown () {
			if (this.selected < 2) this.selected += 2
			if (this.selected >= 2 && (this.local || this.hosting)) this.selected = 4
		},
		onPressEnter () {
			const ref = this.$refs.msg_box
			switch (this.selected) {
				case 0:
					if (ref.focused) {
						this.sendMessage()
					} else {
						ref.onClick()
					}
					break
				case 1:
					this.sendMessage()
					break
				case 2:
					if (this.local) this.startLocalGame()
					else this.toggleReady()
					break;
				case 3:
					this.leaveLobby()
					break
				case 4:
					this.changeSettings()
					break
			}
		},
		onPressBack () {
			const ref = this.$refs.msg_box
			if (ref && ref.focused) {
				ref.blur()
			}
		},
		sendMessage () {
			if (!this.message) return
			Networker.sendAction("SEND_MESSAGE", {
				text: this.message
			})
			this.message = ""
		},
		setMessage (id, value) {
			this.message = value
		},
		setSelected (id) {
			this.selected = +id
		},
		startLocalGame () {
			this.$emit("start", {
				players: this.player_data
			})
		},
		toggleReady () {
			Networker.sendAction("TOGGLE_READY")
		}
	},
	mounted () {
		UI.on("PRESS_BACK", this.onPressBack)
		UI.on("PRESS_DOWN", this.onPressDown)
		UI.on("PRESS_ENTER", this.onPressEnter)
		UI.on("PRESS_LEFT", this.onPressLeft)
		UI.on("PRESS_RIGHT", this.onPressRight)
		UI.on("PRESS_UP", this.onPressUp)
	},
	name: "lobby",
	props: [ "host", "hosting", "local", "map", "messages", "mode", "name", "players", "teams", "teamsize" ]
}
</script>

<style lang="less" scoped>
.buttons {
	background-color: #000;
	border: 1px #fff solid;
	display: flex;
	font-size: .75em;
	margin-top: 4em;
	width: 100%;

	.item {
		flex: 1 0;
		justify-content: center;
	}
}

.chatbox {
	display: flex;

	.fullwidth {
		flex: 1 0;
	}

	.item {
		background-color: #000;
		border: 1px #fff solid;
		font-size: 3em;
	}

	.selected {
		background-color: #fff;
		font-size: 3em;
		padding: .25em;
	}
}

.container {
	flex: 1;
	position: static;
}

.details {
	background-color: #000;
	border: 1px #fff solid;
	color: #fff;
	font-size: 2em;
	margin-bottom: 1.5em;
	padding: .5em;

	b {
		font-size: 1.5em;
	}
}

.lobby {
	align-items: flex-end;
	bottom: 0;
	display: flex;
	font-size: 4em;
	justify-content: flex-start;
	left: 0;
	position: absolute;
}

.messages {
	background-color: #000;
	border: 1px #fff solid;
	color: #fff;
	display: flex;
	flex-direction: column;
	font-size: 2em;
	height: 15em;
	justify-content: flex-end;
	overflow: hidden;
	padding: .5em;
	text-shadow: none;
	word-break: break-word;

	.speaker {
		font-weight: bold;
	}
}

.options {
	bottom: 0;
	font-size: .25em;
	left: 100em;
	min-width: 40em;
}

.player-list-container {
	flex: 0 1;
	font-size: .75em;
	margin-right: 1em;
}

.selected {
	font-size: 4em;
	padding: .25em;
}
</style>